#! /bin/bash
WINEBIN="bisheng-engine-wine8"
PACKAGE_VERSION="3.0.3"

PACKAGE_NAME="printer-driver-bisheng-brother-dcp-l2510d-series"
PRINTER_NAME=( "Brother DCP-L2510D series" "Brother DCP-L2530DW series" "Brother DCP-L2535D series" "Brother DCP-L2535DW series" "Brother DCP-L2537DW Printer" "Brother DCP-L2550DN series" "Brother DCP-L2550DW series" "Brother DCP-L2551DN series" "Brother DCP-B7500D series" "Brother DCP-B7520DW series" "Brother DCP-B7530DN series" "Brother DCP-B7535DW series" "Brother DCP-7090 Printer" "Brother DCP-7090DW Printer" "Brother DCP-7190DW Printer" "Brother DCP-7095D Printer" "Brother DCP-7190DN Printer" "Brother DCP-7195DW Printer" "Brother MFC-L2690DW Printer" "Brother MFC-L2710DN series" "Brother MFC-L2710DW series" "Brother MFC-L2713DW Printer" "Brother MFC-L2715D series" "Brother MFC-L2715DW series" "Brother MFC-L2717DW Printer" "Brother MFC-L2730DN Printer" "Brother MFC-L2730DW series" "Brother MFC-L2750DW series" "Brother MFC-L2770DW series" "Brother MFC-B7700D Printer" "Brother MFC-B7710DN Printer" "Brother MFC-B7715DW series" "Brother MFC-B7720DN Printer" "Brother MFC-7390 Printer" "Brother MFC-7490D Printer" "Brother MFC-7890DN Printer" "Brother MFC-7895DW Printer" "Brother HL-L2390DW Printer" "Brother HL-L2395DW series" "Brother FAX-L2710DN Printer" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"
echo 1 > "$CONTAINER_PATH/DriverType.log"

WINEPREFIX="$CONTAINER_PATH" $WINEBIN winecfg -v win7
WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "/opt/deepinwine/printer_drv/printer-driver-bisheng-brother-dcp-l2510d-series/winprint.reg"
WINEPREFIX=$CONTAINER_PATH $WINEBIN wineserver -w 
